// ScriptDemo1.java

import java.util.*;

import javax.script.*;

public class ScriptDemo1
{
   public static void main (String [] args)
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a list of all discovered factories as ScriptEngineFactories.

      List<ScriptEngineFactory> factories = manager.getEngineFactories ();

      // Display each script engine factory's metadata and create the script
      // engine.

      for (ScriptEngineFactory factory: factories)
      {
           System.out.println ("Full name = " + factory.getEngineName ());

           System.out.println ("Version = " + factory.getEngineVersion ());

           System.out.println ("Extensions");
           List<String> extensions = factory.getExtensions ();
           for (String extension: extensions)
                System.out.println ("   " + extension);

           System.out.println ("Language name = " +
                               factory.getLanguageName ());

           System.out.println ("Language version = " +
                               factory.getLanguageVersion ());

           System.out.println ("MIME Types");
           List<String> mimetypes = factory.getMimeTypes ();
           for (String mimetype: mimetypes)
                System.out.println ("   " + mimetype);

           System.out.println ("Short Names");
           List<String> shortnames = factory.getNames ();
           for (String shortname: shortnames)
                System.out.println ("   " + shortname);

           String [] params =
           {
              ScriptEngine.ENGINE,
              ScriptEngine.ENGINE_VERSION,
              ScriptEngine.LANGUAGE,
              ScriptEngine.LANGUAGE_VERSION,
              ScriptEngine.NAME,
              "THREADING"
           };
           for (String param: params)
           {
                System.out.printf ("Parameter %s = %s", param,
                                   factory.getParameter (param));
                System.out.println ();
           }

           ScriptEngine engine = factory.getScriptEngine ();
           System.out.println (engine);

           System.out.println ();
      }     
   }
}
