// ScriptDemo10.java

import java.awt.*;

import java.io.*;

import javax.script.*;

import javax.swing.*;
import javax.swing.event.*;

public class ScriptDemo10
{
   public static void main (String [] args) throws Exception
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Evaluate the caldisp.js script.

      engine.eval (new FileReader ("caldisp.js"));

      // Have the script send its output to out.html.

      engine.getContext ().setWriter (new PrintWriter ("out.html"));

      // Define document within JavaScript.

      String script = "var document = new Object (); " +
                      "document.writeln = function (s) { println (s); }; " +
                      "document.write = function (s) { print (s); }";
      engine.eval (script);

      // Invoke caldisp ("#b0e0e6", "#00ff00", "white", "yellow", "#808080");.

      Invocable inv = (Invocable) engine;

      inv.invokeFunction ("caldisp", "#b0e0e6", "#00ff00", "white", "yellow",
                          "#808080");

      // Create a GUI to show the calendar.

      Runnable r = new Runnable ()
                   {
                       public void run ()
                       {
                          JFrame frame = new JFrame ();
                          frame.setDefaultCloseOperation
                            (JFrame.EXIT_ON_CLOSE);
                          String path;
                          path = "file:///" +
                                 (new File ("").getAbsolutePath ()) +
                                 "/out.html";
                          try
                          {
                             JEditorPane ep = new JEditorPane (path);
                             frame.setContentPane (new JScrollPane (ep));
                          }
                          catch (IOException ioe)
                          {
                          }
                          frame.setSize (200, 300);
                          frame.setVisible (true);
                       }
                   };
      EventQueue.invokeLater (r);
   }
}
