// ScriptDemo3.java

import javax.script.*;

public class ScriptDemo3
{
   public static void main (String [] args) throws ScriptException
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Initialize the age script variable to 85 (an Integer).

      engine.put ("age", 85);

      // Evaluate a script that determines if a person can obtain an amount to
      // deduct from their taxable income based on age.

      engine.eval ("var ageAmount = 0.0; if (age >= 65) ageAmount += 6000;");

      // Retrieve the ageAmount script variable (a Double) and output its
      // value.

      System.out.println ("ageAmount = " + engine.get ("ageAmount"));
   }
}
