// ScriptDemo4.java

import javax.script.*;

public class ScriptDemo4
{
   public static void main (String [] args) throws ScriptException
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Initialize the color and shape script variables.

      engine.put ("color", "red");
      engine.put ("shape", "rectangle");

      // Evaluate a script that outputs the values of these variables.

      engine.eval ("println (color); println (shape);");

      // Save the current bindings object.

      Bindings oldBindings = engine.getBindings (ScriptContext.ENGINE_SCOPE);

      // Replace the bindings with a new bindings that overrides color and
      // shape.

      Bindings newBindings = engine.createBindings ();
      newBindings.put ("color", "blue");
      engine.setBindings (newBindings, ScriptContext.ENGINE_SCOPE);
      engine.put ("shape", "triangle");

      // Evaluate the script.

      engine.eval ("println (color); println (shape);");

      // Restore the original bindings.

      engine.setBindings (oldBindings, ScriptContext.ENGINE_SCOPE);

      // Evaluate the script.

      engine.eval ("println (color); println (shape);");
   }
}
