// ScriptDemo6.java

import java.io.*;

import javax.script.*;

public class ScriptDemo6
{
   final static int ITER_MAX = 50000;

   public static void main (String [] args) throws ScriptException
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Specify a simple script to demonstrate compilation improvement.

      String script = "function sum (x)"+
                      "{"+
                      "   return x*(x+1)/2;"+
                      "};";

      // Time script parsing and intermediate code execution.

      long now = System.currentTimeMillis ();
      for (int i = 0; i < ITER_MAX; i++)
           engine.eval (script);
      System.out.println (System.currentTimeMillis () - now);

      Compilable compilable = null;
      if (engine instanceof Compilable)
      {
          compilable = (Compilable) engine;
          CompiledScript cs = compilable.compile (script);

          // Time intermediate code execution.

          now = System.currentTimeMillis ();
          for (int i = 0; i < ITER_MAX; i++)
               cs.eval ();
          System.out.println (System.currentTimeMillis () - now);
      }
   }
}
