// ScriptDemo7.java

import javax.script.*;

public class ScriptDemo7
{
   public static void main (String [] args) throws Exception
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Evaluate a script that defines a global function and an object.

      String script = "function makeEmployee(name, salary)"+
                      "{"+
                      "    var obj = new Object();"+
                      "    obj.name = name;"+
                      "    obj.salary = salary;"+
                      "    obj.print = function()"+
                      "    {"+
                      "        println (\"name = \"+obj.name);"+
                      "        println (\"salary = \"+obj.salary);"+
                      "    };"+
                      "    return obj;"+
                      "}";
    
      engine.eval (script);

      Invocable invocable = null;
      if (engine instanceof Invocable)
      {
          invocable = (Invocable) engine;

          // Invoke the makeEmployee() function to make an object.
        
          Object emp = invocable.invokeFunction ("makeEmployee", "John Doe",
                                                 40000.0);

          // Print the employee via the object's print() member function.

          invocable.invokeMethod (emp, "print");
      }
   }
}
