// ScriptDemo9.java

import java.io.*;

import javax.script.*;

public class ScriptDemo9
{
   public static void main (String [] args) throws Exception
   {
      // Create a ScriptEngineManager that discovers all script engine
      // factories (and their associated script engines) that are visible to
      // the current thread's classloader.

      ScriptEngineManager manager = new ScriptEngineManager ();

      // Obtain a ScriptEngine that supports the JavaScript short name.

      ScriptEngine engine = manager.getEngineByName ("JavaScript");

      // Define the functions specified by caldisp.js.

      engine.eval (new FileReader ("caldisp.js"));

      // Define document within JavaScript.

      String script = "var document = new Object (); " +
                      "document.writeln = function (s) { println (s); }; " +
                      "document.write = function (s) { print (s); }";
      engine.eval (script);

      // Invoke caldisp ("#b0e0e6", "#00ff00", "white", "yellow", "#808080");.

      Invocable inv = (Invocable) engine;

      inv.invokeFunction ("caldisp", "#b0e0e6", "#00ff00", "white", "yellow",
                          "#808080");
   }
}
